<?php
/*
Plugin Name: Pinterest Plugin
Plugin Script: pinterest.php
Plugin URI: http://resell-rights-weekly.com
Description: Easy to use Pintrest features for Wordpress - Add Pinterest Follow Buttons to any post or page with support for multiple Pintrest accounts!
Version: 1.1
Author: RRW
Author URI: http://resell-rights-weekly.com
*/

/*  Copyright 2012  All Rights Reserved.  (email : info@resell-rights-weekly.com)

    This program is copyright; you cannot redistribute it and/or modify
    it.
	
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
*/

register_activation_hook( __FILE__, 'net66_pintrest_install' );
add_action('admin_menu','net66_pintrest_create_menu');


function net66_pintrest_install() {
    if ( version_compare( get_bloginfo( 'version' ), '3.1', '<' ) ) {
        deactivate_plugins( basename( __FILE__ ) ); // Deactivate our plugin if wordpress version below 3.1
    }

}

function net66_pintrest_create_menu(){
		add_options_page( 'WP-Pintrest', 'WP-Pintrest Settings', 'manage_options', __FILE__, 'net66_menu_settings_page' );
}

function net66_menu_settings_page(){
	// Settings Menu
	?>
		<div class="wrap">
		<?php screen_icon(); ?>
		<h2>WP Pintrest</h2>
		<form action="options.php" method="post">
			<?php settings_fields('net66_pintrest_options'); ?>
			<?php do_settings_sections('net66_pintrest'); ?>
			<input name="Submit" type="submit" value="Save Changes" />
		</form>
	</div>
	<p><h2>Instructions</h2><br>
	This adds two easy to use shortcodes to your Wordpress set-up.
	<br>
	<br><font size=+1><b>[pinfollow]</b> - Creates a Pintrest Follow Me Button.  Used on its own it will use the pintrest user specified above and a default Pintrest follow button.</font>
	<br><br>
	You can specify a user for the follow button and a different button by adding parameters to the shortcode.
	<br><b>[pinfollow username='fredsmith']</b> will create a button to follow user <i>fredsmith</i> overriding what is set above.
	<br>You can also specify a different button by using the parameter <b><i>button</i></b> with small, medium, large or follow as the button type.  If not specified it will use the medium button.  The follow type includes the wording 'follow me'.  Examples;<br>
	[pinfollow button='small']<br>[pinfollow button='follow']<br>[pinfollow user='jimmysmith' button='small']
	</p><p>
		<br><font size=+1><b>[pinit]</b> - Creates a Pin It URL Link with optional description and image.</font>
	<br><br>
	When used on its own it will use your sites url and the default image if specified in the settings above.  But there is so much more you can do...<br><br>
	You can specify a url with the url parameter, specify an image url with the image parameter, optionally show a pin counter in one of two formats, and you can also put in an optional description.<br>
	<br><b>Example:</b> [pinit url='http://mysite.com/page/' image='http://mysite.com/image.png' counter='vertical' description='this is a great book']<br>
	<br><b>Remember these extra parameters are optional you can use any or all of them.</b><br>The counter can be set to vertical, horizontal or none (if not specified it will use none).
	<br><br><b>More examples:</b> <br>
	[pinit counter='vertical']<br>[pinit url='http://asite.com/page1/blah.html' description='My friends cool site']button='follow']<br>[pinit counter='horizontal' url='http://google.com' description='This is google']
	
	</p>
	<?php
}

add_action('admin_init', 'net66_pintrest_admin_init');
function net66_pintrest_admin_init(){
	register_setting(
		'net66_pintrest_options',
		'net66_pintrest_options',
		'net66_pintrest_validate_options'
	);
	add_settings_section(
		'net66_pintrest_main',
		'Pintrest Settings',
		'net66_pintrest_section_text',
		'net66_pintrest'
	);
	add_settings_field(
		'net66_pintrest_text_string',
		'Pintrest Username',
		'net66_pintrest_setting_input',
		'net66_pintrest',
		'net66_pintrest_main'
	);
		add_settings_field(
		'net66_pintrest_text_stringb',
		'Default Pin Image URL',
		'net66_pintrest_setting_inputb',
		'net66_pintrest',
		'net66_pintrest_main'
	);
}

// Draw the section header
function net66_pintrest_section_text() {
	echo '<p>Settings.</p>';
}

// Display and fill the form field
function net66_pintrest_setting_input() {
	// get option 'text_string' value from the database
	$options = get_option( 'net66_pintrest_options' );
	$text_string = $options['text_string'];
	// echo the field
	echo "<input id='text_string' name='net66_pintrest_options[text_string]' type='text' value='$text_string' />";
}
function net66_pintrest_setting_inputb() {
	// get option 'text_string' value from the database
	$options = get_option( 'net66_pintrest_options' );
	$text_stringb=$options['text_stringb'];
	// echo the field
	echo "<input id='text_stringb' name='net66_pintrest_options[text_stringb]' type='text' value='$text_stringb' />";
}

// Validate user input (we want text only)
function net66_pintrest_validate_options( $input ) {
	//$valid['text_string'] = preg_replace( '/[^a-zA-Z]/', '', $input['text_string'] );
	$valid['text_stringb']=$input['text_stringb'];
	$valid['text_string']=$input['text_string'];
	if( $valid['text_string'] != $input['text_string'] ) {
		add_settings_error(
			'net66_pintrest_text_string',
			'net66_pintrest_texterror',
			'Incorrect value entered!',
			'error'
		);		
	}
	
	return $valid;
}



function net66_pintrest_follow_sc($attr) {
	$options = get_option( 'net66_pintrest_options' );
	$pintrest_username = $options['text_string'];
	

	// Configure button size
	switch($attr['button']){
		
		// Small button
		case "small":
			$follow_image = '<img src="http://passets-cdn.pinterest.com/images/small-p-button.png" width="16" height="16" alt="Follow Me on Pinterest" />';
			break;
				
		// medium button
		case "follow":
			$follow_image = '<img src="http://passets-cdn.pinterest.com/images/follow-on-pinterest-button.png" width="156" height="26" alt="Follow Me on Pinterest" />';
			break;

		// pill button
		case "large":
			$follow_image = '<img src="http://passets-cdn.pinterest.com/images/big-p-button.png" width="61" height="61" alt="Follow Me on Pinterest" />';
			break;
			
		default:
			$follow_image = '<img src="http://passets-cdn.pinterest.com/images/pinterest-button.png" width="78" height="26" alt="Follow Me on Pinterest" />';
			break;

	} // end button size switch
	
	if( isset( $attr['username'] ) ) {
		$follow_name = $attr['username'];}
	else{
		$follow_name = $pintrest_username;
	}
	$pin = '<a href="http://pinterest.com/'.$follow_name.'/">'.$follow_image.'</a>';
		
	return $pin;
											
}// End follow shortcode handler\



function net66_pintrest_pinit_sc($attr, $content) {
	$options = get_option( 'net66_pintrest_options' );
	$pintrest_imageurl = $options['text_stringb'];
	

	if( isset( $attr['url'] ) ) {
		$pin_url = $attr['url'];}
	else{
		$pin_url = home_url();
	}
	
	
	if( isset( $attr['image'] ) ) {
		$pin_image_url = $attr['image'];}
	else{
		$pin_image_url = $pintrest_imageurl;
	}
	

if ( isset($attr['counter'] ) ) {
		$pincounter=substr($attr['counter'],0,1); 	}
	else {
		$pincounter='n';
	}
// Configure counter
	switch($pincounter){
		
		// Small button
		case "h":
			$pin_counter = 'horizontal';
			break;
				
		// medium button
		case "v":
			$pin_counter = 'vertical';
			break;

		default:
			$pin_counter = 'none';
			break;

	} // end button size switch
	
	if( isset( $attr['description'] ) ) {
		$pin_desc = $attr['description'];}
	else{
		$pin_desc = '';
	}



	$pin = '<a href="http://pinterest.com/pin/create/button/?url='.urlencode($pin_url).'&media='.urlencode($pin_image_url).'&description='.urlencode($pin_desc).'&count-layout='.$pin_counter.'">Pin It</a>';
	

				
	return $pin;
											
}// End shortcode handler\

// Register Shortcodes
add_shortcode( 'pinfollow', 'net66_pintrest_follow_sc' );
add_shortcode( 'pinit', 'net66_pintrest_pinit_sc' );

?>